# NOTE: Derived from blib/lib/InfoSys/FreeDB/Response/Hello.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package InfoSys::FreeDB::Response::Hello;

#line 160 "blib/lib/InfoSys/FreeDB/Response/Hello.pm (autosplit into blib/lib/auto/InfoSys/FreeDB/Response/Hello/new_from_content_ref.al)"
sub new_from_content_ref {
    my $class = shift;
    my $content_ref = shift;

    # Convert $opt->{content_ref} to @content_ref
    my @content_ref = split(/[\n\r]+/, ${$content_ref} );

    # Parse first line
    my $line = shift(@content_ref);
    my ($code) = $line =~ /^\s*(\d{3})\s+/;
    defined ($code) ||
        throw Error::Simple ('ERROR: InfoSys::FreeDB::Response::Hello::new_from_content_ref, first line of specified \'content_ref\' does not contain a code.');
    my %opt;
    if ($code == 200) {
        %opt = (
            code => $code,
            result => 'Handshake successful',
        );
    }
    elsif ($code == 402) {
        %opt = (
            code => $code,
            result => 'Already shook hands',
        );
    }
    elsif ($code == 431) {
        %opt = (
            code => $code,
            error => 1,
            result => 'Handshake not successful, closing connection',
        );
    }
    else {
        throw Error::Simple ("ERROR: InfoSys::FreeDB::Response::Hello::new_from_content_ref, unknown code '$code' returned. Allowed codes are 200, 402 and 431.");
    }

    # Create a new object and return it
    return( $class->new( \%opt ) );
}

1;
# end of InfoSys::FreeDB::Response::Hello::new_from_content_ref
